diff --git a/gcc/diagnostic.c b/gcc/diagnostic.c
index acc44b1..0083eda 100644
--- a/gcc/diagnostic.c
+++ b/gcc/diagnostic.c
@@ -44,9 +44,9 @@ along with GCC; see the file COPYING3.  If not see
 #endif
 
 #define pedantic_warning_kind(DC)			\
-  ((DC)->pedantic_errors ? DK_ERROR : DK_WARNING)
-#define permissive_error_kind(DC) ((DC)->permissive ? DK_WARNING : DK_ERROR)
-#define permissive_error_option(DC) ((DC)->opt_permissive)
+  ((DC)->m_pedantic_errors ? DK_ERROR : DK_WARNING)
+#define permissive_error_kind(DC) ((DC)->m_permissive ? DK_WARNING : DK_ERROR)
+#define permissive_error_option(DC) ((DC)->m_opt_permissive)
 
 /* Prototypes.  */
 static bool diagnostic_impl (rich_location *, int, const char *,
@@ -55,7 +55,6 @@ static bool diagnostic_n_impl (rich_location *, int, int, const char *,
 			       const char *, va_list *,
 			       diagnostic_t) ATTRIBUTE_GCC_DIAG(5,0);
 
-static void error_recursion (diagnostic_context *) ATTRIBUTE_NORETURN;
 static void real_abort (void) ATTRIBUTE_NORETURN;
 
 /* Name of program invoked, sans directories.  */
@@ -86,8 +85,8 @@ char *
 file_name_as_prefix (diagnostic_context *context, const char *f)
 {
   const char *locus_cs
-    = colorize_start (pp_show_color (context->printer), "locus");
-  const char *locus_ce = colorize_stop (pp_show_color (context->printer));
+    = colorize_start (pp_show_color (context->m_printer), "locus");
+  const char *locus_ce = colorize_stop (pp_show_color (context->m_printer));
   return build_message_string ("%s%s:%s ", locus_cs, f, locus_ce);
 }
 
@@ -122,62 +121,62 @@ diagnostic_set_caret_max_width (diagnostic_context *context, int value)
 {
   /* One minus to account for the leading empty space.  */
   value = value ? value - 1 
-    : (isatty (fileno (pp_buffer (context->printer)->stream))
+    : (isatty (fileno (pp_buffer (context->m_printer)->stream))
        ? get_terminal_width () - 1: INT_MAX);
   
   if (value <= 0) 
     value = INT_MAX;
 
-  context->caret_max_width = value;
+  context->m_caret_max_width = value;
 }
 
 /* Initialize the diagnostic message outputting machinery.  */
 void
-diagnostic_initialize (diagnostic_context *context, int n_opts)
+diagnostic_context::initialize (int n_opts)
 {
   int i;
 
   /* Allocate a basic pretty-printer.  Clients will replace this a
      much more elaborated pretty-printer if they wish.  */
-  context->printer = XNEW (pretty_printer);
-  new (context->printer) pretty_printer ();
+  m_printer = XNEW (pretty_printer);
+  new (m_printer) pretty_printer ();
 
-  memset (context->diagnostic_count, 0, sizeof context->diagnostic_count);
-  context->warning_as_error_requested = false;
-  context->n_opts = n_opts;
-  context->classify_diagnostic = XNEWVEC (diagnostic_t, n_opts);
+  memset (m_diagnostic_count, 0, sizeof m_diagnostic_count);
+  m_warning_as_error_requested = false;
+  m_n_opts = n_opts;
+  m_classify_diagnostic = XNEWVEC (diagnostic_t, n_opts);
   for (i = 0; i < n_opts; i++)
-    context->classify_diagnostic[i] = DK_UNSPECIFIED;
-  context->show_caret = false;
-  diagnostic_set_caret_max_width (context, pp_line_cutoff (context->printer));
+    m_classify_diagnostic[i] = DK_UNSPECIFIED;
+  m_show_caret = false;
+  diagnostic_set_caret_max_width (this, pp_line_cutoff (m_printer));
   for (i = 0; i < rich_location::STATICALLY_ALLOCATED_RANGES; i++)
-    context->caret_chars[i] = '^';
-  context->show_option_requested = false;
-  context->abort_on_error = false;
-  context->show_column = false;
-  context->pedantic_errors = false;
-  context->permissive = false;
-  context->opt_permissive = 0;
-  context->fatal_errors = false;
-  context->dc_inhibit_warnings = false;
-  context->dc_warn_system_headers = false;
-  context->max_errors = 0;
-  context->internal_error = NULL;
-  diagnostic_starter (context) = default_diagnostic_starter;
-  context->start_span = default_diagnostic_start_span_fn;
-  diagnostic_finalizer (context) = default_diagnostic_finalizer;
-  context->option_enabled = NULL;
-  context->option_state = NULL;
-  context->option_name = NULL;
-  context->last_location = UNKNOWN_LOCATION;
-  context->last_module = 0;
-  context->x_data = NULL;
-  context->lock = 0;
-  context->inhibit_notes_p = false;
-  context->colorize_source_p = false;
-  context->show_ruler_p = false;
-  context->parseable_fixits_p = false;
-  context->edit_context_ptr = NULL;
+    m_caret_chars[i] = '^';
+  m_show_option_requested = false;
+  m_abort_on_error = false;
+  m_show_column = false;
+  m_pedantic_errors = false;
+  m_permissive = false;
+  m_opt_permissive = 0;
+  m_fatal_errors = false;
+  m_inhibit_warnings = false;
+  m_warn_system_headers = false;
+  m_max_errors = 0;
+  m_internal_error = NULL;
+  diagnostic_starter (this) = default_diagnostic_starter;
+  m_start_span = default_diagnostic_start_span_fn;
+  diagnostic_finalizer (this) = default_diagnostic_finalizer;
+  m_option_enabled = NULL;
+  m_option_state = NULL;
+  m_option_name = NULL;
+  m_last_location = UNKNOWN_LOCATION;
+  m_last_module = 0;
+  m_x_data = NULL;
+  m_lock = 0;
+  m_inhibit_notes_p = false;
+  m_colorize_source_p = false;
+  m_show_ruler_p = false;
+  m_parseable_fixits_p = false;
+  m_edit_context_ptr = NULL;
 }
 
 /* Maybe initialize the color support. We require clients to do this
@@ -185,7 +184,7 @@ diagnostic_initialize (diagnostic_context *context, int n_opts)
    without a VALUE, it initializes with DIAGNOSTICS_COLOR_DEFAULT.  */
 
 void
-diagnostic_color_init (diagnostic_context *context, int value /*= -1 */)
+diagnostic_context::color_init (int value /*= -1 */)
 {
   /* value == -1 is the default value.  */
   if (value < 0)
@@ -204,46 +203,46 @@ diagnostic_color_init (diagnostic_context *context, int value /*= -1 */)
       else
 	value = DIAGNOSTICS_COLOR_DEFAULT;
     }
-  pp_show_color (context->printer)
+  pp_show_color (m_printer)
     = colorize_init ((diagnostic_color_rule_t) value);
 }
 
 /* Do any cleaning up required after the last diagnostic is emitted.  */
 
 void
-diagnostic_finish (diagnostic_context *context)
+diagnostic_context::finish ()
 {
   /* Some of the errors may actually have been warnings.  */
-  if (diagnostic_kind_count (context, DK_WERROR))
+  if (kind_count (DK_WERROR))
     {
       /* -Werror was given.  */
-      if (context->warning_as_error_requested)
-	pp_verbatim (context->printer,
+      if (m_warning_as_error_requested)
+	pp_verbatim (m_printer,
 		     _("%s: all warnings being treated as errors"),
 		     progname);
       /* At least one -Werror= was given.  */
       else
-	pp_verbatim (context->printer,
+	pp_verbatim (m_printer,
 		     _("%s: some warnings being treated as errors"),
 		     progname);
-      pp_newline_and_flush (context->printer);
+      pp_newline_and_flush (m_printer);
     }
 
   diagnostic_file_cache_fini ();
 
-  XDELETEVEC (context->classify_diagnostic);
-  context->classify_diagnostic = NULL;
+  XDELETEVEC (m_classify_diagnostic);
+  m_classify_diagnostic = NULL;
 
-  /* diagnostic_initialize allocates context->printer using XNEW
+  /* diagnostic_context::initialize allocates m_printer using XNEW
      and placement-new.  */
-  context->printer->~pretty_printer ();
-  XDELETE (context->printer);
-  context->printer = NULL;
+  m_printer->~pretty_printer ();
+  XDELETE (m_printer);
+  m_printer = NULL;
 
-  if (context->edit_context_ptr)
+  if (m_edit_context_ptr)
     {
-      delete context->edit_context_ptr;
-      context->edit_context_ptr = NULL;
+      delete m_edit_context_ptr;
+      m_edit_context_ptr = NULL;
     }
 }
 
@@ -317,12 +316,12 @@ static char *
 diagnostic_get_location_text (diagnostic_context *context,
 			      expanded_location s)
 {
-  pretty_printer *pp = context->printer;
+  pretty_printer *pp = context->m_printer;
   const char *locus_cs = colorize_start (pp_show_color (pp), "locus");
   const char *locus_ce = colorize_stop (pp_show_color (pp));
   const char *file = s.file ? s.file : progname;
   int line = strcmp (file, N_("<built-in>")) ? s.line : 0;
-  int col = context->show_column ? s.column : 0;
+  int col = context->m_show_column ? s.column : 0;
 
   const char *line_col = maybe_line_and_column (line, col);
   return build_message_string ("%s%s%s:%s", locus_cs, file,
@@ -346,7 +345,7 @@ diagnostic_build_prefix (diagnostic_context *context,
 
   const char *text = _(diagnostic_kind_text[diagnostic->kind]);
   const char *text_cs = "", *text_ce = "";
-  pretty_printer *pp = context->printer;
+  pretty_printer *pp = context->m_printer;
 
   if (diagnostic_kind_color[diagnostic->kind])
     {
@@ -464,20 +463,20 @@ bt_err_callback (void *data ATTRIBUTE_UNUSED, const char *msg, int errnum)
 void
 diagnostic_check_max_errors (diagnostic_context *context, bool flush)
 {
-  if (!context->max_errors)
+  if (!context->m_max_errors)
     return;
 
-  int count = (diagnostic_kind_count (context, DK_ERROR)
-	       + diagnostic_kind_count (context, DK_SORRY)
-	       + diagnostic_kind_count (context, DK_WERROR));
+  int count = (context->kind_count (DK_ERROR)
+	       + context->kind_count (DK_SORRY)
+	       + context->kind_count (DK_WERROR));
 
-  if (count >= context->max_errors)
+  if (count >= context->m_max_errors)
     {
       fnotice (stderr,
 	       "compilation terminated due to -fmax-errors=%u.\n",
-	       context->max_errors);
+	       context->m_max_errors);
       if (flush)
-	diagnostic_finish (context);
+	context->finish ();
       exit (FATAL_EXIT_CODE);
     }
 }
@@ -485,8 +484,7 @@ diagnostic_check_max_errors (diagnostic_context *context, bool flush)
 /* Take any action which is expected to happen after the diagnostic
    is written out.  This function does not always return.  */
 void
-diagnostic_action_after_output (diagnostic_context *context,
-				diagnostic_t diag_kind)
+diagnostic_context::action_after_output (diagnostic_t diag_kind)
 {
   switch (diag_kind)
     {
@@ -498,12 +496,12 @@ diagnostic_action_after_output (diagnostic_context *context,
 
     case DK_ERROR:
     case DK_SORRY:
-      if (context->abort_on_error)
+      if (m_abort_on_error)
 	real_abort ();
-      if (context->fatal_errors)
+      if (m_fatal_errors)
 	{
 	  fnotice (stderr, "compilation terminated due to -Wfatal-errors.\n");
-	  diagnostic_finish (context);
+	  finish ();
 	  exit (FATAL_EXIT_CODE);
 	}
       break;
@@ -519,7 +517,7 @@ diagnostic_action_after_output (diagnostic_context *context,
 	  backtrace_full (state, 2, bt_callback, bt_err_callback,
 			  (void *) &count);
 
-	if (context->abort_on_error)
+	if (m_abort_on_error)
 	  real_abort ();
 
 	fnotice (stderr, "Please submit a full bug report,\n"
@@ -534,9 +532,9 @@ diagnostic_action_after_output (diagnostic_context *context,
       }
 
     case DK_FATAL:
-      if (context->abort_on_error)
+      if (m_abort_on_error)
 	real_abort ();
-      diagnostic_finish (context);
+      finish ();
       fnotice (stderr, "compilation terminated.\n");
       exit (FATAL_EXIT_CODE);
 
@@ -548,31 +546,30 @@ diagnostic_action_after_output (diagnostic_context *context,
 /* True if the last module or file in which a diagnostic was reported is
    different from the current one.  */
 
-static bool
-last_module_changed_p (diagnostic_context *context,
-		       const line_map_ordinary *map)
+bool
+diagnostic_context::last_module_changed_p (const line_map_ordinary *map)
 {
-  return context->last_module != map;
+  return m_last_module != map;
 }
 
 /* Remember the current module or file as being the last one in which we
    report a diagnostic.  */
 
-static void
-set_last_module (diagnostic_context *context, const line_map_ordinary *map)
+void
+diagnostic_context::set_last_module (const line_map_ordinary *map)
 {
-  context->last_module = map;
+  m_last_module = map;
 }
 
 void
-diagnostic_report_current_module (diagnostic_context *context, location_t where)
+diagnostic_context::report_current_module (location_t where)
 {
   const line_map_ordinary *map = NULL;
 
-  if (pp_needs_newline (context->printer))
+  if (pp_needs_newline (m_printer))
     {
-      pp_newline (context->printer);
-      pp_needs_newline (context->printer) = false;
+      pp_newline (m_printer);
+      pp_needs_newline (m_printer) = false;
     }
 
   if (where <= BUILTINS_LOCATION)
@@ -582,29 +579,29 @@ diagnostic_report_current_module (diagnostic_context *context, location_t where)
 			    LRK_MACRO_DEFINITION_LOCATION,
 			    &map);
 
-  if (map && last_module_changed_p (context, map))
+  if (map && last_module_changed_p (map))
     {
-      set_last_module (context, map);
+      set_last_module (map);
       if (! MAIN_FILE_P (map))
 	{
 	  map = INCLUDED_FROM (line_table, map);
 	  const char *line_col
 	    = maybe_line_and_column (LAST_SOURCE_LINE (map),
-				     context->show_column
+				     m_show_column
 				     ? LAST_SOURCE_COLUMN (map) : 0);
-	  pp_verbatim (context->printer,
+	  pp_verbatim (m_printer,
 		       "In file included from %r%s%s%R", "locus",
 		       LINEMAP_FILE (map), line_col);
 	  while (! MAIN_FILE_P (map))
 	    {
 	      map = INCLUDED_FROM (line_table, map);
 	      line_col = maybe_line_and_column (LAST_SOURCE_LINE (map), 0);
-	      pp_verbatim (context->printer,
+	      pp_verbatim (m_printer,
 			   ",\n                 from %r%s%s%R", "locus",
 			   LINEMAP_FILE (map), line_col);
 	    }
-	  pp_verbatim (context->printer, ":");
-	  pp_newline (context->printer);
+	  pp_verbatim (m_printer, ":");
+	  pp_newline (m_printer);
 	}
     }
 }
@@ -613,8 +610,8 @@ void
 default_diagnostic_starter (diagnostic_context *context,
 			    diagnostic_info *diagnostic)
 {
-  diagnostic_report_current_module (context, diagnostic_location (diagnostic));
-  pp_set_prefix (context->printer, diagnostic_build_prefix (context,
+  context->report_current_module (diagnostic_location (diagnostic));
+  pp_set_prefix (context->m_printer, diagnostic_build_prefix (context,
 							    diagnostic));
 }
 
@@ -622,10 +619,10 @@ void
 default_diagnostic_start_span_fn (diagnostic_context *context,
 				  expanded_location exploc)
 {
-  pp_set_prefix (context->printer,
+  pp_set_prefix (context->m_printer,
 		 diagnostic_get_location_text (context, exploc));
-  pp_string (context->printer, "");
-  pp_newline (context->printer);
+  pp_string (context->m_printer, "");
+  pp_newline (context->m_printer);
 }
 
 void
@@ -633,8 +630,8 @@ default_diagnostic_finalizer (diagnostic_context *context,
 			      diagnostic_info *diagnostic)
 {
   diagnostic_show_locus (context, diagnostic->richloc, diagnostic->kind);
-  pp_destroy_prefix (context->printer);
-  pp_flush (context->printer);
+  pp_destroy_prefix (context->m_printer);
+  pp_flush (context->m_printer);
 }
 
 /* Interface to specify diagnostic kind overrides.  Returns the
@@ -642,19 +639,18 @@ default_diagnostic_finalizer (diagnostic_context *context,
    range.  If OPTION_INDEX is zero, the new setting is for all the
    diagnostics.  */
 diagnostic_t
-diagnostic_classify_diagnostic (diagnostic_context *context,
-				int option_index,
-				diagnostic_t new_kind,
-				location_t where)
+diagnostic_context::classify_diagnostic (int option_index,
+					 diagnostic_t new_kind,
+					 location_t where)
 {
   diagnostic_t old_kind;
 
   if (option_index < 0
-      || option_index >= context->n_opts
+      || option_index >= m_n_opts
       || new_kind >= DK_LAST_DIAGNOSTIC_KIND)
     return DK_UNSPECIFIED;
 
-  old_kind = context->classify_diagnostic[option_index];
+  old_kind = m_classify_diagnostic[option_index];
 
   /* Handle pragmas separately, since we need to keep track of *where*
      the pragmas were.  */
@@ -665,64 +661,63 @@ diagnostic_classify_diagnostic (diagnostic_context *context,
       /* Record the command-line status, so we can reset it back on DK_POP. */
       if (old_kind == DK_UNSPECIFIED)
 	{
-	  old_kind = !context->option_enabled (option_index,
-					       context->option_state)
-	    ? DK_IGNORED : (context->warning_as_error_requested
+	  old_kind = !m_option_enabled (option_index, m_option_state)
+	    ? DK_IGNORED : (m_warning_as_error_requested
 			    ? DK_ERROR : DK_WARNING);
-	  context->classify_diagnostic[option_index] = old_kind;
+	  m_classify_diagnostic[option_index] = old_kind;
 	}
 
-      for (i = context->n_classification_history - 1; i >= 0; i --)
-	if (context->classification_history[i].option == option_index)
+      for (i = m_n_classification_history - 1; i >= 0; i --)
+	if (m_classification_history[i].option == option_index)
 	  {
-	    old_kind = context->classification_history[i].kind;
+	    old_kind = m_classification_history[i].kind;
 	    break;
 	  }
 
-      i = context->n_classification_history;
-      context->classification_history =
-	(diagnostic_classification_change_t *) xrealloc (context->classification_history, (i + 1)
+      i = m_n_classification_history;
+      m_classification_history =
+	(diagnostic_classification_change_t *) xrealloc (m_classification_history, (i + 1)
 							 * sizeof (diagnostic_classification_change_t));
-      context->classification_history[i].location = where;
-      context->classification_history[i].option = option_index;
-      context->classification_history[i].kind = new_kind;
-      context->n_classification_history ++;
+      m_classification_history[i].location = where;
+      m_classification_history[i].option = option_index;
+      m_classification_history[i].kind = new_kind;
+      m_n_classification_history ++;
     }
   else
-    context->classify_diagnostic[option_index] = new_kind;
+    m_classify_diagnostic[option_index] = new_kind;
 
   return old_kind;
 }
 
 /* Save all diagnostic classifications in a stack.  */
 void
-diagnostic_push_diagnostics (diagnostic_context *context, location_t where ATTRIBUTE_UNUSED)
+diagnostic_context::push_diagnostics (location_t where ATTRIBUTE_UNUSED)
 {
-  context->push_list = (int *) xrealloc (context->push_list, (context->n_push + 1) * sizeof (int));
-  context->push_list[context->n_push ++] = context->n_classification_history;
+  m_push_list = (int *) xrealloc (m_push_list, (m_n_push + 1) * sizeof (int));
+  m_push_list[m_n_push ++] = m_n_classification_history;
 }
 
 /* Restore the topmost classification set off the stack.  If the stack
    is empty, revert to the state based on command line parameters.  */
 void
-diagnostic_pop_diagnostics (diagnostic_context *context, location_t where)
+diagnostic_context::pop_diagnostics (location_t where)
 {
   int jump_to;
   int i;
 
-  if (context->n_push)
-    jump_to = context->push_list [-- context->n_push];
+  if (m_n_push)
+    jump_to = m_push_list [-- m_n_push];
   else
     jump_to = 0;
 
-  i = context->n_classification_history;
-  context->classification_history =
-    (diagnostic_classification_change_t *) xrealloc (context->classification_history, (i + 1)
+  i = m_n_classification_history;
+  m_classification_history =
+    (diagnostic_classification_change_t *) xrealloc (m_classification_history, (i + 1)
 						     * sizeof (diagnostic_classification_change_t));
-  context->classification_history[i].location = where;
-  context->classification_history[i].option = jump_to;
-  context->classification_history[i].kind = DK_POP;
-  context->n_classification_history ++;
+  m_classification_history[i].location = where;
+  m_classification_history[i].option = jump_to;
+  m_classification_history[i].kind = DK_POP;
+  m_n_classification_history ++;
 }
 
 /* Helper function for print_parseable_fixits.  Print TEXT to PP, obeying the
@@ -800,39 +795,38 @@ print_parseable_fixits (pretty_printer *pp, rich_location *richloc)
 /* Update the diag_class of DIAGNOSTIC based on its location
    relative to any
      #pragma GCC diagnostic
-   directives recorded within CONTEXT.
+   directives recorded within this context.
 
    Return the new diag_class of DIAGNOSTIC if it was updated, or
    DK_UNSPECIFIED otherwise.  */
 
-static diagnostic_t
-update_effective_level_from_pragmas (diagnostic_context *context,
-				     diagnostic_info *diagnostic)
+diagnostic_t
+diagnostic_context::
+update_effective_level_from_pragmas (diagnostic_info *diagnostic) const
 {
   diagnostic_t diag_class = DK_UNSPECIFIED;
 
-  if (context->n_classification_history > 0)
+  if (m_n_classification_history > 0)
     {
       location_t location = diagnostic_location (diagnostic);
 
       /* FIXME: Stupid search.  Optimize later. */
-      for (int i = context->n_classification_history - 1; i >= 0; i --)
+      for (int i = m_n_classification_history - 1; i >= 0; i --)
 	{
-	  if (linemap_location_before_p
-	      (line_table,
-	       context->classification_history[i].location,
-	       location))
+	  if (linemap_location_before_p (line_table,
+					 m_classification_history[i].location,
+					 location))
 	    {
-	      if (context->classification_history[i].kind == (int) DK_POP)
+	      if (m_classification_history[i].kind == (int) DK_POP)
 		{
-		  i = context->classification_history[i].option;
+		  i = m_classification_history[i].option;
 		  continue;
 		}
-	      int option = context->classification_history[i].option;
+	      int option = m_classification_history[i].option;
 	      /* The option 0 is for all the diagnostics.  */
 	      if (option == 0 || option == diagnostic->option_index)
 		{
-		  diag_class = context->classification_history[i].kind;
+		  diag_class = m_classification_history[i].kind;
 		  if (diag_class != DK_UNSPECIFIED)
 		    diagnostic->kind = diag_class;
 		  break;
@@ -846,7 +840,7 @@ update_effective_level_from_pragmas (diagnostic_context *context,
 
 /* Print any metadata about the option used to control DIAGNOSTIC to CONTEXT's
    printer, e.g. " [-Werror=uninitialized]".
-   Subroutine of diagnostic_report_diagnostic.  */
+   Subroutine of diagnostic_context::report_diagnostic.  */
 
 static void
 print_option_information (diagnostic_context *context,
@@ -855,12 +849,12 @@ print_option_information (diagnostic_context *context,
 {
   char *option_text;
 
-  option_text = context->option_name (context, diagnostic->option_index,
+  option_text = context->m_option_name (context, diagnostic->option_index,
 				      orig_diag_kind, diagnostic->kind);
 
   if (option_text)
     {
-      pretty_printer *pp = context->printer;
+      pretty_printer *pp = context->m_printer;
       pp_string (pp, " [");
       pp_string (pp, colorize_start (pp_show_color (pp),
 				     diagnostic_kind_color[diagnostic->kind]));
@@ -879,8 +873,7 @@ print_option_information (diagnostic_context *context,
    Return true if a diagnostic was printed, false otherwise.  */
 
 bool
-diagnostic_report_diagnostic (diagnostic_context *context,
-			      diagnostic_info *diagnostic)
+diagnostic_context::report_diagnostic (diagnostic_info *diagnostic)
 {
   location_t location = diagnostic_location (diagnostic);
   diagnostic_t orig_diag_kind = diagnostic->kind;
@@ -888,59 +881,59 @@ diagnostic_report_diagnostic (diagnostic_context *context,
   /* Give preference to being able to inhibit warnings, before they
      get reclassified to something else.  */
   if ((diagnostic->kind == DK_WARNING || diagnostic->kind == DK_PEDWARN)
-      && !diagnostic_report_warnings_p (context, location))
+      && !diagnostic_report_warnings_p (this, location))
     return false;
 
   if (diagnostic->kind == DK_PEDWARN)
     {
-      diagnostic->kind = pedantic_warning_kind (context);
+      diagnostic->kind = pedantic_warning_kind (this);
       /* We do this to avoid giving the message for -pedantic-errors.  */
       orig_diag_kind = diagnostic->kind;
     }
  
-  if (diagnostic->kind == DK_NOTE && context->inhibit_notes_p)
+  if (diagnostic->kind == DK_NOTE && m_inhibit_notes_p)
     return false;
 
-  if (context->lock > 0)
+  if (m_lock > 0)
     {
       /* If we're reporting an ICE in the middle of some other error,
 	 try to flush out the previous error, then let this one
 	 through.  Don't do this more than once.  */
       if ((diagnostic->kind == DK_ICE || diagnostic->kind == DK_ICE_NOBT)
-	  && context->lock == 1)
-	pp_newline_and_flush (context->printer);
+	  && m_lock == 1)
+	pp_newline_and_flush (m_printer);
       else
-	error_recursion (context);
+	error_recursion ();
     }
 
   /* If the user requested that warnings be treated as errors, so be
      it.  Note that we do this before the next block so that
      individual warnings can be overridden back to warnings with
      -Wno-error=*.  */
-  if (context->warning_as_error_requested
+  if (m_warning_as_error_requested
       && diagnostic->kind == DK_WARNING)
     diagnostic->kind = DK_ERROR;
 
   if (diagnostic->option_index
-      && diagnostic->option_index != permissive_error_option (context))
+      && diagnostic->option_index != permissive_error_option (this))
     {
       /* This tests if the user provided the appropriate -Wfoo or
 	 -Wno-foo option.  */
-      if (! context->option_enabled (diagnostic->option_index,
-				     context->option_state))
+      if (! m_option_enabled (diagnostic->option_index,
+				     m_option_state))
 	return false;
 
       /* This tests for #pragma diagnostic changes.  */
       diagnostic_t diag_class
-	= update_effective_level_from_pragmas (context, diagnostic);
+	= update_effective_level_from_pragmas (diagnostic);
 
       /* This tests if the user provided the appropriate -Werror=foo
 	 option.  */
       if (diag_class == DK_UNSPECIFIED
-	  && (context->classify_diagnostic[diagnostic->option_index]
+	  && (m_classify_diagnostic[diagnostic->option_index]
 	      != DK_UNSPECIFIED))
 	diagnostic->kind
-	  = context->classify_diagnostic[diagnostic->option_index];
+	  = m_classify_diagnostic[diagnostic->option_index];
 
       /* This allows for future extensions, like temporarily disabling
 	 warnings for ranges of source code.  */
@@ -949,9 +942,9 @@ diagnostic_report_diagnostic (diagnostic_context *context,
     }
 
   if (diagnostic->kind != DK_NOTE)
-    diagnostic_check_max_errors (context);
+    diagnostic_check_max_errors (this);
 
-  context->lock++;
+  m_lock++;
 
   if (diagnostic->kind == DK_ICE || diagnostic->kind == DK_ICE_NOBT)
     {
@@ -959,9 +952,9 @@ diagnostic_report_diagnostic (diagnostic_context *context,
 	 error has already occurred.  This is counteracted by
 	 abort_on_error.  */
       if (!CHECKING_P
-	  && (diagnostic_kind_count (context, DK_ERROR) > 0
-	      || diagnostic_kind_count (context, DK_SORRY) > 0)
-	  && !context->abort_on_error)
+	  && (kind_count (DK_ERROR) > 0
+	      || kind_count (DK_SORRY) > 0)
+	  && !m_abort_on_error)
 	{
 	  expanded_location s 
 	    = expand_location (diagnostic_location (diagnostic));
@@ -969,37 +962,37 @@ diagnostic_report_diagnostic (diagnostic_context *context,
 		   s.file, s.line);
 	  exit (ICE_EXIT_CODE);
 	}
-      if (context->internal_error)
-	(*context->internal_error) (context,
-				    diagnostic->message.format_spec,
-				    diagnostic->message.args_ptr);
+      if (m_internal_error)
+	(*m_internal_error) (this,
+			     diagnostic->message.format_spec,
+			     diagnostic->message.args_ptr);
     }
   if (diagnostic->kind == DK_ERROR && orig_diag_kind == DK_WARNING)
-    ++diagnostic_kind_count (context, DK_WERROR);
+    ++kind_count (DK_WERROR);
   else
-    ++diagnostic_kind_count (context, diagnostic->kind);
+    ++kind_count (diagnostic->kind);
 
   diagnostic->message.x_data = &diagnostic->x_data;
   diagnostic->x_data = NULL;
-  pp_format (context->printer, &diagnostic->message);
-  (*diagnostic_starter (context)) (context, diagnostic);
-  pp_output_formatted_text (context->printer);
-  if (context->show_option_requested)
-    print_option_information (context, diagnostic, orig_diag_kind);
-  (*diagnostic_finalizer (context)) (context, diagnostic);
-  if (context->parseable_fixits_p)
+  pp_format (m_printer, &diagnostic->message);
+  (*diagnostic_starter (this)) (this, diagnostic);
+  pp_output_formatted_text (m_printer);
+  if (m_show_option_requested)
+    print_option_information (this, diagnostic, orig_diag_kind);
+  (*diagnostic_finalizer (this)) (this, diagnostic);
+  if (m_parseable_fixits_p)
     {
-      print_parseable_fixits (context->printer, diagnostic->richloc);
-      pp_flush (context->printer);
+      print_parseable_fixits (m_printer, diagnostic->richloc);
+      pp_flush (m_printer);
     }
-  diagnostic_action_after_output (context, diagnostic->kind);
+  action_after_output (diagnostic->kind);
   diagnostic->x_data = NULL;
 
-  if (context->edit_context_ptr)
+  if (m_edit_context_ptr)
     if (diagnostic->richloc->fixits_can_be_auto_applied_p ())
-      context->edit_context_ptr->add_fixits (diagnostic->richloc);
+      m_edit_context_ptr->add_fixits (diagnostic->richloc);
 
-  context->lock--;
+  m_lock--;
 
   return true;
 }
@@ -1050,8 +1043,8 @@ verbatim (const char *gmsgid, ...)
   text.args_ptr = &ap;
   text.format_spec = _(gmsgid);
   text.x_data = NULL;
-  pp_format_verbatim (global_dc->printer, &text);
-  pp_newline_and_flush (global_dc->printer);
+  pp_format_verbatim (global_dc->m_printer, &text);
+  pp_newline_and_flush (global_dc->m_printer);
   va_end (ap);
 }
 
@@ -1068,18 +1061,18 @@ diagnostic_append_note (diagnostic_context *context,
 
   va_start (ap, gmsgid);
   diagnostic_set_info (&diagnostic, gmsgid, &ap, &richloc, DK_NOTE);
-  if (context->inhibit_notes_p)
+  if (context->m_inhibit_notes_p)
     {
       va_end (ap);
       return;
     }
-  saved_prefix = pp_get_prefix (context->printer);
-  pp_set_prefix (context->printer,
+  saved_prefix = pp_get_prefix (context->m_printer);
+  pp_set_prefix (context->m_printer,
                  diagnostic_build_prefix (context, &diagnostic));
-  pp_format (context->printer, &diagnostic.message);
-  pp_output_formatted_text (context->printer);
-  pp_destroy_prefix (context->printer);
-  pp_set_prefix (context->printer, saved_prefix);
+  pp_format (context->m_printer, &diagnostic.message);
+  pp_output_formatted_text (context->m_printer);
+  pp_destroy_prefix (context->m_printer);
+  pp_set_prefix (context->m_printer, saved_prefix);
   diagnostic_show_locus (context, &richloc, DK_NOTE);
   va_end (ap);
 }
@@ -1105,7 +1098,7 @@ diagnostic_impl (rich_location *richloc, int opt,
       if (kind == DK_WARNING || kind == DK_PEDWARN)
 	diagnostic.option_index = opt;
     }
-  return diagnostic_report_diagnostic (global_dc, &diagnostic);
+  return global_dc->report_diagnostic (&diagnostic);
 }
 
 /* Implement inform_n, warning_n, and error_n, as documented and
@@ -1122,7 +1115,7 @@ diagnostic_n_impl (rich_location *richloc, int opt, int n,
                                   ap, richloc, kind);
   if (kind == DK_WARNING)
     diagnostic.option_index = opt;
-  return diagnostic_report_diagnostic (global_dc, &diagnostic);
+  return global_dc->report_diagnostic (&diagnostic);
 }
 
 /* Wrapper around diagnostic_impl taking a variable argument list.  */
@@ -1472,18 +1465,18 @@ fnotice (FILE *file, const char *cmsgid, ...)
    so give up now.  But do try to flush out the previous error.
    This mustn't use internal_error, that will cause infinite recursion.  */
 
-static void
-error_recursion (diagnostic_context *context)
+void
+diagnostic_context::error_recursion ()
 {
-  if (context->lock < 3)
-    pp_newline_and_flush (context->printer);
+  if (m_lock < 3)
+    pp_newline_and_flush (m_printer);
 
   fnotice (stderr,
 	   "Internal compiler error: Error reporting routines re-entered.\n");
 
-  /* Call diagnostic_action_after_output to get the "please submit a bug
+  /* Call action_after_output to get the "please submit a bug
      report" message.  */
-  diagnostic_action_after_output (context, DK_ICE);
+  action_after_output (DK_ICE);
 
   /* Do not use gcc_unreachable here; that goes through internal_error
      and therefore would cause infinite recursion.  */
